/****************************************************************************

		DCOMMAIN.C Dual Acces to a COM Port

		Author: FB.DRUILHE    (C) 1989, 1990
		Date:   February 07, 1990

*****************************************************************************/
#define VERSION "3.0"

#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "dcomstr.h"

/*********************** External *******************************************/
#define FALSE 0
#define TRUE (!FALSE)

/* Low Level com_acces */

extern void connect_it_com();
extern void disconnect_it_com();

extern int  com_rx(int i);
extern int  com_tx(int i);

extern int com_port;

/* Hi Level Task */
extern void exec_com_tx(int i);
extern void exec_com_rx(int i);
extern void setup_com_ports();

extern void exec_key();
extern void restore_init_key();

/* Screen Management */
extern int affiche_choix( struct choix *c);
extern void open_main_window(int clr);
extern cursof();
extern curson();
extern cursav();

/************************ Internal *******************************************/

int end_prog= 0;

#define N_KEY 20
extern char key[N_KEY][75] ;

/*****************************************************************************/

char last_realease[35];

struct choix title_menu = {
	1, 21, FALSE,
	5, 2, 75, 24, FALSE,
	BLUE, WHITE, YELLOW,
	" D C O M ",
	"           (C) 1989, 1990 FB.DRUILHE",
	"",
	"   F1:  toggle from COMMAND to USER Speed",
	"   F2:  use External Program Interpretor",
	"   F3:",
	"   F4:  send a Break (DTR as 108.2)",
	"   F5:  send a Break to Both COM",
	"   F6:  toggle Bip on Error Signaling",
	"   F7:",
	"   F8:",
	"   F9:  display date and time",
	"   F10: acces Main Menu",
	"",
	"   Home:  Display this screen   Alt-Z: toggle Screen Zoom      ",
	"   Alt-A: Run Automatic Test    Alt-P: Communication Parameters",
	"   Alt-S: Transmit Source       Alt-D: Receive Destination     ",
	"   Alt-C: Command Format        Alt-U: User Format             ",
	"   Alt-X: Exit to DOS          ",
	"   <Alt-0>..<Alt-9>: for Predefined keys",
	"",
	last_realease
	};

char    sys_error_str[40];

struct choix sys_err_menu = {
	1, 1, FALSE,
	10, 11, 60, 13, FALSE,
	BLACK, WHITE, RED,
	" D C O M  System Error ",
	sys_error_str
	};

void default_setup()
{
	restore_init_key();
	/* Connect COM1 port */
	com_port = 1;
	disconnect_it_com();
	setup_com_ports();
	connect_it_com();
}

void restore_setup()
{
	disconnect_it_com();
	curson();
	window(1, 1, 80, 25);
	clrscr();
}

/*****************************************************************************/

void sys_error( char *mes)
{
	strcpy( sys_error_str, mes);
	while (affiche_choix( &sys_err_menu )) /* nop */;
}

int ctrlbreak()
{
	restore_setup();
	sys_error( "CTRL_BREAK: process abort by user" );
	curson();
	return(0);
}

void title()
{
	sprintf(last_realease,"       Version %s      Updated  %s   (%s)", VERSION, __DATE__, __TIME__);

	while (affiche_choix( &title_menu)) /* Nothing */;
}

void main_menu()
{

	/* Internal declaration */

	/* Control Break Connection */
	setcbrk( 1 ); /* Always */
	ctrlbrk(ctrlbreak);

	/* Loop */
	while (!end_prog)
	  {
	  /* Task Polling */
	  /* COM1 */
	  if (com_rx(1))      exec_com_rx(1);
	  else if (kbhit())   exec_key();
	  else if (com_tx(1)) exec_com_tx(1);
	  /* COM2 */
	  if (com_rx(2))      exec_com_rx(2);
	  else if (com_tx(2)) exec_com_tx(2);
	  }
}

/*****************************************************************************/

main(int argc, char *argv[])
{
	cursav();
	cursof();
	clrscr();
	/* Title */
	title();

	/* Main Window */
	open_main_window(TRUE /* Clear */);

	/* Default SETUP */
	if (argc>1) strcpy(key[11], argv[1]);
	default_setup();

	/* Main Menu */
	main_menu();

	/* Restore Setup */
	restore_setup();
	exit(0);
}