/************************************************************************

		    D C O M T E S T . C

                   Function for Automatic Testing

                   Author: FB.DRUILHE
		   Update: February 20, 1990

*************************************************************************/

#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <stdio.h>
#include <time.h>
#include "dcomstr.h"

#define FALSE 0
#define TRUE (!FALSE)

extern void com_break();
extern int  read_com_status(int ic, int pr);
extern void setup_com_port( int affi);
extern void write_com(int ic, char ch);
extern char get_com(int ic);
extern char tx_pattern(int ic);
extern void count_error(int ic);
extern int  com_rx(int ic);
extern int  com_tx(int ic);
extern int  set_com_format( int ic, int command);
extern void setup_com_ports();
extern void enable_it_com();
extern void tx_set_pattern(int ic, int i);
extern void start_error_count(int ic);
extern void screen_error(int ic);

extern long int pat_err[2];
extern long int pat_rx[2];
extern int  bip_on_err;
extern int  setup_key(int i, char *title);
extern int  setup_str(char *str, char *title);
extern void open_window( struct choix *c, char *b, int clr);
extern void close_window( struct choix *c, char *b);
extern void affiche_select( struct choix *c, int i, int res);

extern int  load_string( FILE *f, char *c);
extern int  com_port;

#define N_KEY 20
extern char key[N_KEY][75];

time_t	curr_time;

/*********************** Test Parameters ********************************/
int test_mode=0;                                 /* Default Full Duplex */
int test_number_trial=5;                             /* Number of Tests */
long int test_size=100000L;                             /* Size of test */
extern char com_speed_str[2][12];                     /* Command Format */
extern char user_speed_str[2][12];                       /* Data Format */

char AT_str[6][75];                                       /* AT Strings */
char test_title[75]="[Untitled Test]";                 /* Title of test */
FILE *res;                                            /* Output Results */

/*********************** Menu Variables *********************************/
int num_no_err, num_some_err, num_connect, num_trial;
long int tot_err, tot_char;

struct choix test_menu = {
	1, 5, FALSE,
	30, 2, 58, 8, FALSE,
	BLACK, WHITE, YELLOW,
	" AUTOMATIC TEST ",
	"Edit    Setup",
	"Run     Test     Alt-A",
	"Save    Setup",
	"Recover Setup",
	"Chain   Tests"
	};


char test_mode_str[45];
char test_size_str[45];
char test_number_str[45];
char test_stop_on_err_str[45];
char test_speed_str[4][45];

struct choix setup_test_menu = {
	1, 18, FALSE,
	3, 3, 77, 22, FALSE,
	BLACK, WHITE, YELLOW,
	" SETUP AUTO TEST ",
	test_title,
	test_mode_str,
	test_number_str,
	test_size_str,
	test_stop_on_err_str,
	test_speed_str[0],
	test_speed_str[1],
	test_speed_str[2],
	test_speed_str[3],
	"------------------------ Initial AT String ---------------------",
	AT_str[0], AT_str[1],
	"----------------------- Connexion AT String --------------------",
	AT_str[2], AT_str[3],
	"-------------------------- End AT String -----------------------",
	AT_str[4], AT_str[5]
	};

struct choix setup_test_mode_menu = {
	1, 5, TRUE,
	25, 5, 45, 11, FALSE,
	BLACK, WHITE, YELLOW,
	" TYPE OF TEST ",
	"Full Duplex ",
	"Tx= 1; Rx= 1",
	"Tx= 2; Rx= 2",
	"Tx= 1; Rx= 2",
	"Tx= 2; Rx= 1"
	};

int tx_enable[2][5] = { {TRUE,  TRUE,  FALSE, TRUE,  FALSE},
			{TRUE,  FALSE, TRUE,  FALSE, TRUE}  };

int rx_enable[2][5] = { {TRUE,  TRUE,  FALSE, FALSE, TRUE },
			{TRUE,  FALSE, TRUE,  TRUE,  FALSE} };

int bit_mask[5] = { 0x9090, 0x0090, 0x9000, 0x1080, 0x8010 };

char buff[80*24*2];

#define INT_SCREEN	21, 4, 79, 22

char screen_test_title[80];

struct choix screen_test = {
	1, 1, FALSE,
	20, 2, 80, 23, FALSE,
	BLACK, WHITE, YELLOW,
	screen_test_title, /* " AUTOMATIC TEST ", */
	""
	};

/**************************** Chain Menu ***************************/
double size_scaling=1;                     /* Size of Test Scaling */
double number_scaling=1;                 /* Number of Test Scaling */
int resume_COM=FALSE;                    /* Reverse COM1 and COM2 */

char    chain_gener_file_str[75];
char	chain_output_file_str[75];
char	chain_size_scaling_str[45];
char	chain_number_scaling_str[45];
char	chain_resume_COM_str[45];
char	chain_line_prg_str[75];
char	chain_line_file_str[75];
char	chain_timeout_str[75];

struct choix setup_chain_test_menu = {
	1, 9, FALSE,
	5, 7, 75, 17, FALSE,
	BLACK, WHITE, YELLOW,
	" CHAIN TESTS ",
	"************************** RUN TESTS *************************",
	chain_line_prg_str,
	chain_line_file_str,
	chain_gener_file_str,
	chain_output_file_str,
	chain_size_scaling_str,
	chain_number_scaling_str,
	chain_resume_COM_str,
	chain_timeout_str,
	};

char file_done_str[20]   = "File Done";
char file_to_run_str[20] = "File To Do";
char fn[17][20] = {  "1",  "2",  "3",  "4",  "5",  "6",
		     "7",  "8",  "9", "10", "11", "12",
		    "13", "14", "15", "16", "FileName.Ext" };

struct choix run_chain_test_menu = {
	3, 20, FALSE,
	1, 2, 19, 23, FALSE,
	BLACK, WHITE, YELLOW,
	" FILES ",
	file_done_str,
	file_to_run_str,
	"-----------",
	fn[0],  fn[1],  fn[2],  fn[3],  fn[4],
	fn[5],  fn[6],  fn[7],  fn[8],  fn[9],
	fn[10], fn[11], fn[12], fn[13], fn[14],
	fn[15], fn[16]
	};

/*******************************************************************/
struct choix abort_test_menu = {
	1, 5, FALSE,
	25, 12, 50, 18, FALSE,
	BLACK, WHITE, RED,
	" ABORT TEST ",
	"continue",
	"Abort Error Count",
	"Abort Test",
	"Abort Chain",
	"Abort All"
	};


int abort_mesure, abort_test, abort_chain, abort_all;

void set_abort_level( int v)
{
	 abort_test_menu.c_max = 5-2+v;
	 abort_test_menu.c_sy = 18-2+v;
	 abort_test_menu.c_value = 1;
}

void ask_abort()
{
	int i, xi, yi;
	xi=wherex();
	yi=wherey();
	while (kbhit()) getch() /* void Char */;
	i=affiche_choix(&abort_test_menu);
	switch (i) {
	case 5: abort_all    = TRUE;
	case 4: abort_chain  = TRUE;
	case 3: abort_test   = TRUE;
	case 2: abort_mesure = TRUE;
	}
	window( INT_SCREEN );
	gotoxy( xi, yi);
}
/************************************************************************/
int stop_on_err=FALSE;                            /* Stop Test on Error */

unsigned test_delay1=3000;
unsigned test_delay2=2000;

int timeout=FALSE;
int timeout_value;
double timeout_sec= 30.0;

void interrupt (*old_vect_time)();

void interrupt timmer_it()
{
	if ((!timeout)&&(timeout_value))
	  {
	  if (!--timeout_value) timeout=TRUE;
	  }
}

void connect_timmer_it()
{
	old_vect_time=getvect(0x1C);
	setvect(0x1C, timmer_it);
}

void disconnect_timmer_it()
{
	setvect(0x1C, old_vect_time);
}

/************************************************************************/

void send_str( int i)
{
	char cc;
	int ic;
	char *c;
	c=AT_str[i];
	if (strlen(c))
	  {
	  if (*c=='1') ic=1;
	  else if (*c=='2') ic=2;
	  else
	    {
	    sys_error("SYNTAX ERROR INTO TEST SETUP");
	    abort_chain=abort_test=abort_mesure=TRUE;
	    return;
	    }
	  c++;
	  do
	    {
	    cc=*c++;
	    if (cc=='~') delay(1000);
	    else if (cc==94) write_com(ic, ((cc=*c++)-64));
	    else if (cc=='|')
	      {
	      int sav=com_port;
	      com_port=ic;
	      com_break();
	      com_port=sav;
	      }
	    else if (cc) write_com(ic, cc);
	    } while (cc);
	  }
}

int wait_com( int ic, char *ident_string)
{
	int abort=FALSE;
	char *id;
	id=ident_string;
	do {
	   char c;
	   if (com_rx(ic))
	     {
	     c=get_com(ic);
	     /* cprintf("[%c %c]",c, *id); */
	     if (c==*id) *id++;
	     else id=ident_string;
	     }
	   else if (kbhit()) abort=(getch()==27);
	   } while ((!abort)&&(*id!=0));
	return(!abort);
}

void save_test_setup( FILE *f )
{
	int i;
	fprintf( f, "%s\n", test_title);
	for (i=0;i<6;i++) fprintf( f,"%s\n", AT_str[i]);
	for (i=0;i<2;i++) fprintf( f,"%s\n", com_speed_str[i]);
	for (i=0;i<2;i++) fprintf( f,"%s\n", user_speed_str[i]);
	/* Parameters */
	fprintf(f, "%1u %5u %12lu\n",
		test_mode, test_number_trial, test_size);
}

void recover_test_setup( FILE *f )
{
	int i;
	load_string( f, test_title);
	for (i=0;i<6;i++) load_string( f, AT_str[i]);
	for (i=0;i<2;i++) load_string( f, com_speed_str[i]);
	for (i=0;i<2;i++) load_string( f, user_speed_str[i]);
	/* Parameters */
	fscanf(f, "%1u %5u %12lu\n",
		&test_mode, &test_number_trial, &test_size);
}

int getfile( char *in_str, char *file_name,
	     int num_file, int display, int clr,
	     char *b)
{
	int done, sdone, i_f, tot_file;
	struct ffblk Fline;
	char file_drive[3], file_ext[5], file_dir[64];
	if (display)
	  {
	  /* Display Window */
	  open_window( &run_chain_test_menu, b, clr);
	  for (i_f=0; i_f<17; i_f++)  strcpy(fn[i_f], "");
	  }
	/* Initialize Loop */
	i_f=0;
	tot_file=0;
	done=FALSE;
	sdone=TRUE; /* Default is not Found */
	do
	  {
	  /* Look for Dos File */
	  if (i_f)  done=findnext( &Fline );
	  else      done=findfirst( in_str, &Fline, 0);
	  i_f++;
	  if ((!done)&&(i_f==num_file))
	    {
	    fnsplit( in_str, file_drive, file_dir, file_name, file_ext);
	    strcpy(file_name, file_dir);
	    strcat(file_name, Fline.ff_name);
	    sdone=FALSE;
	    }
	  if (!done)
	    {
	    tot_file++;
	    if (display)
	      {
	      if (num_file<8)
		{
		if (i_f<=17) strcpy(fn[i_f-1], Fline.ff_name);
		run_chain_test_menu.c_value=num_file+3;
		}
	      else
		{
		/* Store Result if into the Range */
		if ((i_f>=num_file-8)&&(i_f<=(num_file-8+17)))
		  strcpy(fn[i_f-(num_file-8)-1], Fline.ff_name);
		run_chain_test_menu.c_value=8+3;
		}
	      }
	    }
	  } while (!done);
	/* Display Window */
	if ((display)&&(!sdone))
	  {
	  sprintf(file_done_str,   "Done   =%3d", num_file-1);
	  sprintf(file_to_run_str, "To Run =%3d", tot_file-num_file+1);
	  /* Affiche Feeld */
	  for (i_f=1; i_f<=run_chain_test_menu.c_max; i_f++)
	    affiche_select( &run_chain_test_menu,
			    i_f, run_chain_test_menu.c_value);

	  /* affiche_choix( &run_chain_test_menu ); */
	  /* gotoxy(20, 20); */
	  /* cprintf("File [%s]", file_name); */
	  }
	return(sdone);
}

int setup_test()
{
	int i;
	char temp[75];
	do
	  {
	  /* Compose Test Menu */
	  sprintf(test_mode_str,   "Test Mode               : %s",
		  setup_test_mode_menu.c_select[test_mode]);
	  sprintf(test_number_str, "Number of tests         : %d", test_number_trial);
	  sprintf(test_size_str,   "Size of Test (char)     : %ld", test_size);
	  if (!stop_on_err)
	    sprintf(test_stop_on_err_str,"Stop Test on Errors     : NO");
	  else
	    sprintf(test_stop_on_err_str,"Stop Test on Errors     : YES");

	  for (i=0;i<2;i++) sprintf(test_speed_str[i],  "Command Format COM%u     : %s",i+1, com_speed_str[i]);
	  for (i=0;i<2;i++) sprintf(test_speed_str[i+2],"User    Format COM%u     : %s",i+1, user_speed_str[i]);

	  /* Affiche Test Menu */
	  i=affiche_choix( &setup_test_menu );
	  if (i)
	    {
	    if (i==1) setup_str(test_title," Enter Test TITLE ");
	    else if (i==2)
	      {
	      int ii;
	      ii=affiche_choix( &setup_test_mode_menu );
	      if (ii) test_mode=ii-1;
	      }
	    else if (i==3)
	      {
	      sprintf(temp, "%d", test_number_trial);
	      setup_str(temp, " Enter Number of Tests ");
	      sscanf(temp, "%d", &test_number_trial);
	      }
	    else if (i==4)
	      {
	      sprintf(temp, "%ld", test_size);
	      setup_str(temp, " Enter Size of Test ");
	      sscanf(temp, "%ld", &test_size);
	      }
	    else if (i==5) stop_on_err = ~stop_on_err;
	    else if ((i==6)||(i==7)) setup_str(com_speed_str[i-6], " Enter COMMAND Format ");
	    else if ((i==8)||(i==9)) setup_str(user_speed_str[i-8], " Enter USER Format ");
	    else if ((i==10)||(i==13)||(i==16)) /* Rien */;
	    else if ((i==11)||(i==12))
	      setup_str(AT_str[i-11],
	      " Enter COM number Folowed by AT String (~ delay, | Break, ^ for Ctrl) ");
	    else if ((i==14)||(i==15))
	      setup_str(AT_str[i-14+2],
	      " Enter COM number Folowed by AT String (~ delay, | Break, ^ for Ctrl) ");
	    else if ((i==17)||(i==18))
	      setup_str(AT_str[i-17+4],
	      " Enter COM number Folowed by AT String (~ delay, | Break, ^ for Ctrl) ");
	    }
	  } while (i);
}


int run_test(int wait, int foutp, char *run_test_title)
{
	int sav_com_port=com_port;
	int numero=1;
	int first_run;
	int mask, pater;
	int com10, num_com10;
	long int tst_chr, max_test;

	/* Open Window */
	sprintf( screen_test_title, " AUTOMATIC TEST %s ", run_test_title);
	open_window( &screen_test, buff, TRUE );
	gotoxy(2,2);
	textcolor( RED );
	cprintf("%s", test_title);
	textcolor( WHITE );
	window( INT_SCREEN );

	/* Initialization */
	abort_test=FALSE;
	first_run=TRUE;
	num_no_err=0;
	num_some_err=0;
	tot_err=0;
	tot_char=0;
	num_connect=0;
	num_trial=0;
	num_com10=0;
	com10=0;
	tst_chr = (long int) ((double) test_size) * size_scaling;
	max_test= (long int) (((double) test_number_trial)*number_scaling + 0.5);
	if (max_test<2) max_test=2;

	/* Start Test */
	for (numero=1;
	     ((numero<=max_test)&&(!abort_test));
	     numero++)
	  {
	  char *c;
	  int i, ic;
	  long int nchr=0;

	  if (!resume_COM)
	    {
	    cprintf("%3d ", numero);
	    if (foutp) fprintf(res, " %3d ", numero);
	    }
	  abort_mesure = FALSE;

	  /* Goes int Command Mode and Speed */
	  if (set_com_format(1, TRUE)) goto abort_test_label;
	  if (set_com_format(2, TRUE)) goto abort_test_label;

	  /* Send Commands */
	  if (first_run) for (i=0;i<2;i++) send_str( i );
	  else           for (i=0;i<2;i++) send_str( i+4);
	  for (i=0;i<2;i++) send_str( i+2 );
	  first_run=FALSE;

	  /* Timeout for CTS CD Detection Timeout_Sec Seconds */
	  timeout=FALSE;
	  timeout_value=(int) (timeout_sec*18);
	  connect_timmer_it();
	  num_trial++;

	  /* Wait CTS, CD on Both */
	  mask = bit_mask[test_mode];
	  do
	     {
	     pater = (read_com_status(2, FALSE)<<8) | read_com_status(1, FALSE);
	     if (kbhit()) if (getch()==27) ask_abort();
	     if (timeout) abort_mesure=TRUE;
	     } while (((pater&mask)!=mask)&&(!abort_mesure));
	  disconnect_timmer_it();
	  if (abort_mesure) goto abort_mesure_label;
	  if (abort_test)   goto abort_test_label;

	  /* Data are now Exanged */
	  if (!resume_COM) cprintf("RUN ");
	  /* Goes into User Mode and Speed */
	  if (set_com_format(1, FALSE)) goto abort_test_label;
	  if (set_com_format(2, FALSE)) goto abort_test_label;
	  delay( test_delay2 );
	  flush_com_buff();

	  /* Start Sending and Count */
	  tx_set_pattern(1, 1 /* QBF1 */);
	  tx_set_pattern(2, 1 /* QBF1 */);
	  start_error_count(0 );
	  start_error_count(1 );

	  do {
	     /* Check Mode */
	     if (rx_enable[0][test_mode]) if (com_rx(1)) count_error(0);
	     if (rx_enable[1][test_mode]) if (com_rx(2)) count_error(1);
	     if (tx_enable[0][test_mode]) if (com_tx(1))
	       {
	       write_com(1, tx_pattern(1));
	       nchr++;
	       }
	     if (tx_enable[1][test_mode]) if (com_tx(2))
	       {
	       write_com(2, tx_pattern(2));
	       nchr++;
	       }
	     if (kbhit()) ask_abort();
	     } while ((!abort_mesure)&&(nchr<tst_chr));


abort_mesure_label:
	  if (abort_mesure)
	    {
	    if (!resume_COM)
	      {
	      cprintf("*** Measurement ABORTED by ");
	      if (timeout) cprintf("TIMEOUT");
	      else         cprintf("USER");
	      cprintf(" ***\n\r");
	      if (foutp)
		{
		if (timeout) fprintf(res, "ABORTED by TIMEOUT");
		else         fprintf(res, "ABORTED by USER");
		}
	      }
	    }
	  else
	    {
	    int tcon=TRUE;
	    /* Update Global results */
	    if ((pat_err[0]==0)&&(pat_err[1]==0)) num_no_err++;
	    else num_some_err++;
	    tot_char += pat_rx[0]+pat_rx[1];
	    tot_err  += pat_err[0]+pat_err[1];

	    /* Display Current Results */
	    if (rx_enable[0][test_mode])
	      {
	      /* Rules for Connect :
		  1) Received Characters > 0;
		  2) BER < 5*10E-2               */
	      tcon&=pat_rx[0]>0;
	      tcon&=(2*pat_err[0])<pat_rx[0];
	      if (!resume_COM)
		{
		cprintf("COM1: ");
		screen_error(0);
		if (rx_enable[1][test_mode]) cprintf("\n\r        ");
		if (foutp) fprintf(res , "Rx1: Err= %8ld (Ch= %8ld) ",
		 pat_err[0], pat_rx[0]);
		}
	      }
	    if (rx_enable[1][test_mode])
	      {
	      /* Same Rules for Connect */
	      tcon&=pat_rx[1]>0;
	      tcon&=(2*pat_err[1])<pat_rx[1];
	      if (!resume_COM)
		{
		cprintf("COM2: ");
		screen_error(1);
		if (foutp) fprintf(res , "Rx2: Err= %8ld (Ch= %8ld)",
				   pat_err[1], pat_rx[1]);
		}
	      }
	    if (!resume_COM) cprintf("\n\r");
	    if (tcon) num_connect++;
	    }
	  if (foutp&&(!resume_COM)) fprintf(res ,"\n");
	  /* Write Connectatbilyti Results */
	  if (++com10==10)
	    {
	    /* Write Connectability Results */
	    cprintf("Connectability = %u / 10\n\r", num_connect - num_com10);
	    if (foutp)
	      fprintf(res , "Connectability = %u / 10\n", num_connect - num_com10);
	    com10=0;
	    num_com10 = num_connect;
	    }
	  if (stop_on_err&&((pat_err[0]+pat_err[1])>0)) ask_abort();
	  }
	/* Normal End of Test */
	/* Display Global Results */
	cprintf("\n                      GLOBAL RESULTS\n\r");
	cprintf("Connectability = %u / %u\n\r", num_connect, num_trial);
	cprintf("Test NO Error= %7d       Test WITH Errors= %4d\n\r",num_no_err, num_some_err);
	cprintf("Error Char= %10ld       Total Char= %10ld\n\r", tot_err, tot_char);
	if (wait)
	  {
	  cprintf("\n                                 << Hit ESC >> ");
	  while (!(getch()==27)) /* Wait ESC */;
	  }
	else delay(1000);

abort_test_label:
	/* Goes int Command Mode and Speed */
	set_com_format(1, TRUE);
	set_com_format(2, TRUE);
	flush_com_buff();
	com_port=sav_com_port;
	close_window( &screen_test, buff);
	/* Recover Context */
	return(num_no_err);
}

int run_single_test()
{
	set_abort_level( 0 /* Single Test */);
	return( run_test(TRUE, FALSE, ""));
}

void exec_test_menu()
{
      int j;

      do {
	 j=affiche_choix( &test_menu );
	 if (j)
	   {
	   if (j==1) setup_test();
	   else if (j==2) run_single_test();
	   else if (j==3)
	     {
	     /* Save */
	     int i;
	     FILE *skey;

	     if (setup_key(15, " Enter TEST File Name "))
	       {
	       skey = fopen( key[14], "wt");
	       if (skey==NULL)
		 {
		 sys_error("CANNOT OPEN FILE");
		 }
	       else
		 {
		 save_test_setup( skey );
		 fclose(skey);
		 }
	       }
	     }
	   else if (j==4)
	     {
	     /* Recover */
	     int i;
	     FILE *skey;

	     if (setup_key(15, " Enter TEST File Name "))
	       {
	       skey = fopen( key[14], "rt");
	       if (skey==NULL)
		 {
		 sys_error("CANNOT OPEN FILE");
		 }
	       else
		 {
		 recover_test_setup( skey );
		 fclose(skey);
		 }
	       }
	     }
	   else if (j==5)
	     {
	     setup_chain_test();
	     }
	   }
	 } while (j!=0);
}

char chain_title_str[60];

void chain_tests(int append, int show)
{
	/* Chain Test */
	int done, num_chain;
	int sav_bpe;
	char setup_file_name[75];
	char b[25*20*2];
	FILE *skey;

	sav_bpe= bip_on_err;
	bip_on_err=FALSE;

	num_chain=1;
	done=getfile( key[16], setup_file_name, num_chain, show, TRUE, b);
	if (done)
	  {
	  sys_error("CANNOT FOUND FIRST SETUP FILE");
	  abort_all=TRUE;
	  }
	else
	  {
	  if (append) res = fopen( key[17], "at");
	  else        res = fopen( key[17], "wt");
	  if (res==NULL)
	    {
	    sys_error("CANNOT OPEN RESULT FILE");
	    abort_all=TRUE;
	    }
	  else
	    {
	    abort_chain=FALSE;
	    fprintf( res, "*********************************************\n");
	    fprintf( res, "      CONDITION TEST : %s\n", chain_title_str);
	    fprintf( res, "*********************************************\n\n");

	    while ((!done)&&(!abort_chain))
	      {
	      skey = fopen( setup_file_name, "rt");
	      if (skey==NULL)
		{
		sys_error("CANNOT OPEN SETUP FILE");
		abort_chain=TRUE;
		abort_all=TRUE;
		}
	      else
		{
		char ctemp[60];
		/* Load Setup */
		recover_test_setup( skey );
		fclose(skey);
		/* Write Biggining */
		time(&curr_time);
		sprintf(ctemp, "%s", ctime(&curr_time));
		fprintf(res, "*** TEST %4d ***  Date: %s", num_chain, ctemp);
		fprintf(res, "Setup File: %s\n", setup_file_name);
		fprintf(res, "[ %s ]\n", test_title);
		/* Exec Test */
		run_test(FALSE, TRUE, setup_file_name );
		/* Store Results */
		fprintf(res, "----------- GLOBAL RESULTS ---------------\n");
		fprintf(res, "Connectability = %d / %d\n",
				    num_connect, num_trial);
		fprintf(res, "Errors         = %ld     (Err= %d; no Err= %d)\n",
				   tot_err, num_some_err, num_no_err);
		fprintf(res, "Char Received  = %ld\n", tot_char);
		fprintf(res, "\n\n");
		}

	      /* Get New File */
	      num_chain++;
	      done=getfile( key[16], setup_file_name, num_chain, show, FALSE, b);
	      }
	    /* Print Global Results */
	    fclose(res);
	    if (show) close_window( &run_chain_test_menu, b);
	    }
	  }
	bip_on_err = sav_bpe ;
}

void chain_all_tests()
{
	/* Check for no line Test */
	if (strlen(key[18])==0)
	  {
	  /* Single Chain Test */
	  set_abort_level(1);
	  chain_tests(FALSE, TRUE);
	  }
	else
	  {
	  char file_name[80];
	  int first=FALSE;
	  char b[25*20*2];
	  int done, num_file;
	  /* Complete Chain Test */
	  set_abort_level(2);
	  /* Loop for Tests */
	  abort_all=FALSE;
	  /* Get first File */
	  num_file=1;
	  done=getfile( key[19], file_name, num_file, TRUE, TRUE, b);
	  /* Run Test */
	  if (done)
	    {
	    char err_str[70];
	    sprintf( err_str, " CANNOT OPEN FILE [%s]", file_name);
	    sys_error( err_str );
	    }
	  while ((!done)&&(!abort_all))
	    {
	    char dos_prg[80];
	    char buff[80*25*2];
	    /* Program LINE Simulator */
	    sprintf(dos_prg, "%s %s", key[18], file_name);

	    /* Save Screen */
	    gettext( 1, 1, 80, 25, buff  );
	    /* Open Window */
	    curson();
	    window( 1, 1, 80, 25 );
	    textbackground( BLACK );
	    textcolor( WHITE );
	    clrscr();
	    if (system(dos_prg)) sys_error("CANNOT EXECUTE LINE PROGRAM");
	    /* Recover Screen */
	    cursof();
	    puttext( 1, 1, 80, 25, buff  );
	    gotoxy(1, 1);
	    /* Restore COM_SetUp */
	    setup_com_ports();
	    enable_it_com();

	    if (!done)
	      {
	      /* Execute Test */
	      chain_tests(first, FALSE);
	      first=TRUE;
	      /* Get Next Line File Name */
	      num_file++;
	      done=getfile( key[19], file_name, num_file, TRUE, FALSE, b);
	      }
	    }
	  close_window( &run_chain_test_menu, b);
	  }
}

int setup_chain_test()
{
	int i;
	char temp[75];
	do
	  {
	  /* Compose Chain Tests Menu */
	  sprintf(chain_line_prg_str,   "External Line Program   : %s", key[18]);
	  sprintf(chain_line_file_str,  "Generic Line File Name  : %s", key[19]);
	  sprintf(chain_gener_file_str, "Generic Setup File Name : %s", key[16]);
	  sprintf(chain_output_file_str,"Output Results File Name: %s", key[17]);
	  sprintf(chain_size_scaling_str,   "Size of Test Scaling    : %lf", size_scaling);
	  sprintf(chain_number_scaling_str, "Number of Tests Scaling : %lf", number_scaling);
	  sprintf(chain_timeout_str,        "Timeout Value (seconds) : %lf", timeout_sec);
	  if (!resume_COM)
	    sprintf(chain_resume_COM_str,"Resume Results          : NO");
	  else
	    sprintf(chain_resume_COM_str,"Resume Results          : YES");
	  /* Affiche Chain Test Menu */
	  i=affiche_choix( &setup_chain_test_menu );
	  if (i)
	    {
	    /* Display SETUP */
	    if (i==1) chain_all_tests();
	    if (i==2) setup_key(19, " Enter EXTERNAL LINE PROGRAM File Name ");
	    if (i==3) setup_key(20, " Enter GENERIC LINE SETUP File Name ");
	    if (i==4) setup_key(17, " Enter GENERIC TEST File Name ");
	    if (i==5) setup_key(18, " Enter TESTS Results File Name ");
	    else if (i==6)
	      {
	      sprintf(temp, "%lf", size_scaling);
	      setup_str(temp, " Enter Size of Test Scaling ");
	      sscanf(temp, "%lf", &size_scaling);
	      }
	    else if (i==7)
	      {
	      sprintf(temp, "%lf", number_scaling);
	      setup_str(temp, " Enter Number of Tests Scaling ");
	      sscanf(temp, "%lf", &number_scaling);
	      }
	    else if (i==8) resume_COM = ~resume_COM;
	    else if (i==9)
	      {
	      sprintf(temp, "%lf", timeout_sec);
	      setup_str(temp, " Enter Timeout Duration for Connexion (seconds) ");
	      sscanf(temp, "%lf", &timeout_sec);
	      }
	    }
	  } while (i);
}
